const $ = window.$;
const removePopupTime = 3000;
let notes = [];
let contacts = [];
let callsEnded = [];
let selectPhoneContact = null;
let callControllers = [];

/**
 * render numPud when window is a loaded and register events for numPad
 *
 */
$(window).on('load', () => {
  const body = $('body');
  const ignoreRenderNumPadPage = ['manageActivityHistory', 'manageTask'];
  const findIndexPage = ignoreRenderNumPadPage.findIndex(item => location.href.indexOf(item) !== -1);
  if (findIndexPage === -1) {
    renderNumPad();
    const numPad = new ControllerNumPad(0, $(".containerNumPad"), $(".containerNumPad > div:first-child"), $('#outputNumPad'), $('.mainNumPad'));
    //show/hide button pop up caller
    $(document).on('click', '.wildix-call-popups-hide-button', function () {
      const moveableElements = [$('.wildix-call-popups-hide-button'), $('.wildix-call-popups-wrapper')];
      moveableElements.forEach((item) => {
        let right = parseInt(item.css('right'));
        if (item.hasClass('showPopUp')) {
          item.css({right: (right - 285) + 'px'});
        } else {
          item.css({right: (right + 285) + 'px'});
        }
        item.toggleClass('showPopUp');
      })
    });
    $(".digit").on('click', function () {
      const num = $(this).text();
      numPad.digitClick(num.trim());
    });
    $(".buttonNumPad").on('click', () => {
      numPad.toggleVisibility();
    });
    body.keyup(function (e) {
      numPad.keyUp(e);
    });
    $('.fa-long-arrow-left').on('click', () => {
      numPad.removeNumPadSymbol();
    });
    $('#callNumPad').on('click', () => {
      numPad.call();
    });
    body.mousemove(function (e) {
      numPad.toggleVisibilityMainNumPud(e);
    });
  }
});

/**
 * Show popup container after build
 *
 * @param type
 * @param contact
 */
let showPopup = (type, contact) => {
  let popup = $('#popup_' + contact.Id);
  if (popup.length === 0) {
    let popup = $(
      '<div class="wildix-call-popup" id="popup_' + contact.Id + '" data-id="' + contact.Id + '"></div>'
    );
    let container = $('<div class="wildix-call-popup-container"></div>');
    switch (type) {
      case 'EXISTING':
        container.append(
          '<div class="wildix-popup-element"><div class="popup-element-label-left">Name</div>' +
          '<div class="popup-element-label-left"><a href="' + contact.link + '">' + contact.FirstName +
          (contact.LastName !== '' ? (' ' + contact.LastName) : '') + '</a></div>'
        );
        if (contact.Company !== '') {
          container.append(
            '<div class="wildix-popup-element"><div class="popup-element-label-left">Company</div>' +
            '<div class="popup-element-label-left">' + contact.Company + '</div>'
          );
        }
        for (let i = 1; i <= 5; i++) {
          if (contact['Phone' + i] !== undefined) {
            container.append(
              '<div class="wildix-popup-element">' +
              '<div class="popup-element-label-left">Phone ' + i + '</div>' +
              '<div class="popup-element-label-left">' + contact['Phone' + i] + '</div>'
            );
            break;
          }
        }
        break;
      case 'NEW':
        container.append(
          '<div class="wildix-popup-element"><div class="popup-element-label-right">First Name' +
          '</div><div class="popup-element-value"><input name="firstName_' + contact.Id + '" type="text" ' +
          'value="' + contact.FirstName + '"/></div></div>'
        );
        container.append(
          '<div class="wildix-popup-element"><div class="popup-element-label-right">Last Name</div>' +
          '<div class="popup-element-value"><input name="lastName_' + contact.Id + '" type="text" value="' +
          contact.LastName + '"/></div></div>'
        );
        container.append(
          '<div class="wildix-popup-element"><div class="popup-element-label-right">Phone 1</div>' +
          '<div class="popup-element-value"><input name="phone1_' + contact.Id + '" type="text" value="' +
          contact.Phone1 + '"/></div></div>'
        );
        break;
      default:
        break;
    }
    let notesContainer = $(
      '<div class="wildix-popup-notes-container"><hr/><div class="wildix-popup-notes-wrapper">' +
      '<div class="wildix-popup-notes"></div><div class="new-notes-container"></div></div></div>'
    );

    let newNoteContainer = $(
      '<div class="new-note-container"><div class="note-title"><div class="note-field">' +
      '<input type="text" value="" placeholder="Title*"/></div></div><div class="note-description">' +
      '<div class="note-field"><textarea placeholder="Description"></textarea></div></div></div>'
    );
    notesContainer.find('.new-notes-container').append(newNoteContainer);
    let addNoteWrapper = $(
      '<div class="add-note-wrapper"><div class="inf-button btn note-send-button">Add</div></div>'
    );
    notesContainer.find('.new-notes-container').append(addNoteWrapper);
    notesContainer.find('.new-notes-container').append($('<div style="clear:both;"></div>'));
    container.append(notesContainer);
    // .note-send-button
    $(document).on('click', '.wildix-call-popup .new-notes-container .note-send-button', function (event) {
      let popup = $(this).parents('.wildix-call-popup');
      let contactId = popup.data('id');
      let noteTitle = $(this).parents('.new-notes-container').find('.new-note-container')
        .find('.note-field input').val();
      let noteDescription = $(this).parents('.new-notes-container').find('.new-note-container')
        .find('.note-field textarea').val();
      if (noteTitle === '') {
        $(this).parents('.new-notes-container').find('.new-note-container').find('.note-field input').focus();
        event.preventDefault();
        event.stopPropagation();
        return false;
      }
      let note = {
        ActionDescription: noteTitle,
        CreationNotes: noteDescription
      };
      $(this).parents('.new-notes-container').find('.new-note-container').find('.note-field input').val('');
      $(this).parents('.new-notes-container').find('.new-note-container').find('.note-field textarea').val('');
      $(this).parents('.new-notes-container').find('.new-note-container').find('.note-field input').focus();
      chrome.runtime.sendMessage({
        messageType: 'SAVE_NEW_NOTE',
        contactId: contactId,
        note: note
      });
    });
    popup.append(container);
    $('body').append(popup);
    popup.dialog({
      dialogClass: 'wildix-call',
      title: (type === 'NEW') ? 'New contact' : 'Notes',
      minWidth: 500,
      minHeight: 500,
      maxWidth: 500,
      maxHeight: 500,
      width: 500,
      height: 500,
      autoOpen: false,
      modal: false,
      close: function () {
        let contactId = $(this).data('id');
        $(this).remove();
        console.log({messageType: 'CLOSING_POPUP', contactId: contactId});
        chrome.runtime.sendMessage({messageType: 'CLOSING_POPUP', contactId: contactId});
      },
      create: function () {
        let widget = $(this).dialog("widget");
        $('.ui-dialog-titlebar-close', widget).html('<button class="wildix-call-close-button">×</button>');
      }
    });
    popup.dialog('open');
    if (type === 'EXISTING') {
      showNotes(contact.Id);
    }
  } else {
    popup.dialog('open');
  }
};
let showNotes = contactId => {
  console.log('showNotes', contactId);
  let popup = $('.wildix-call-popup[data-id="' + contactId + '"]');
  if (popup.length !== 0) {
    chrome.runtime.sendMessage({messageType: 'GET_NOTES_BY_CONTACT', contactId: contactId});
  }
};
/**
 * Build popup container
 *
 * @param contact
 * @param contactExisting
 * @param collaborationPhone
 */
let drawCall = (contact, contactExisting, collaborationPhone) => {
  console.log('CONTACT', contact)
  const timerSection = $('<div class="timerSection"></div>');
  const callBtnSection = $('<div class="callBtnSection"></div>');
  const popupInfoSection = $('<div class="popupInfoSection"></div>');
  let wildixCallPopupsWrapper = $('.wildix-call-popups-wrapper');
  if (wildixCallPopupsWrapper.length === 0) {
    let wildixCallPopupsContainer = $(
      '<div class="wildix-call-popups-container">' +
      '<div class="wildix-call-popups-hide-button showPopUp"><i class="fa fa-phone"></i></div>' +
      '<div class="wildix-call-popups-wrapper showPopUp"></div>' +
      '</div>'
    );
    wildixCallPopupsWrapper = wildixCallPopupsContainer.find('.wildix-call-popups-wrapper');
    $('body').append(wildixCallPopupsContainer);
  }
  let contactPhone;
  if (selectPhoneContact == null) {
    //incoming call
    contactPhone = contact['Phone' + contact.indexPhone];
    if (typeof contactPhone === 'undefined') {
      for (let i = 0; i <= 5; i++) {
        if (typeof contact['Phone' + i] !== 'undefined' && removeSpecialCharacters(contact['Phone' + i]) === collaborationPhone) {
          contactPhone = contact['Phone' + i];
          break;
        }
      }
    }
  } else {
    //this is done to display the correct selected phone on an outgoing call
    contactPhone = contact[selectPhoneContact];
  }
  let popup = $(
    '<div class="wildix-small-call-popup" id="popup_' + contactPhone + '_' + contact.Id + '" data-call-id="' +
    contact.callId + '">' +
    '</div>'
  );
  popupInfoSection.prepend(generateAvatar(contact));
  if (contactExisting) {
    popupInfoSection.append(
      '<div class="texts"><div class="wildix-contact-title"><a href="' + contact.link + '">' + contact.FirstName +
      ' ' + contact.LastName + '</a></div><div class="wildix-contact-phone">' + removeSpecialCharacters(contactPhone) + '</div></div>'
    );
    if (contact.Company !== '') {
      popupInfoSection.find('.wildix-contact-title').after(
        '<div class="wildix-contact-company">' + contact.Company + '</div>');
    }
    popupInfoSection.append(timerSection);
    popupInfoSection.append(
      '<div class="inf-button primary open-popup-button"><div class="chunky-sprite note-icon" title="Notes">' +
      '</div></div>'
    );
  } else {
    popupInfoSection.append(
      '<div class="texts"><div class="wildix-contact-title">' + contact.FirstName + ' ' +
      contact.LastName + '</div><div class="wildix-contact-phone">' + removeSpecialCharacters(contact.Phone1) + '</div></div>'
    );
    popupInfoSection.append(timerSection);
    popupInfoSection.append('<div class="inf-button primary add-contact-button"><div class="contact-add-icon"></div></div>');
  }
  if (contactExisting) {
    contacts[contact.Id] = contact;
  }
  popup.append(popupInfoSection);
  popup.append(callBtnSection);
  wildixCallPopupsWrapper.append(popup);
  console.log('RENDER BTN SECTION', contact, contact.state);
  const callBtns = new ControllerCallBtn(callBtnSection, contact.callType, contact.callId, contact.state, timerSection, new window.easytimer.Timer());
  console.log('CALL BTN STATE', callBtns.state);
  callControllers.push(callBtns);
  $(document).on(
    'click',
    '.wildix-small-call-popup[data-call-id="' + contact.callId + '"] .open-popup-button',
    () => {
      if (contactExisting || contacts[contact.Id] !== undefined) {
        showPopup('EXISTING', contacts[contact.Id]);
      } else {
        showPopup('NEW', contact);
      }
    }
  );
  $(document).on('click', '.wildix-small-call-popup[data-call-id="' + contact.callId + '"] .add-contact-button', () => {
    chrome.runtime.sendMessage({messageType: 'GET_CALLS'}, searchCallSFromBg.bind(this, contact));
    // chrome.runtime.sendMessage({messageType: 'CREATING_CONTACT', contact: contact, contactId: contact.Id})
  });
  function searchCallSFromBg (c, response) {
    const searchCall = (id, objCall) => {
      for (let CALL in objCall) {
        if (objCall.hasOwnProperty(CALL) && id === CALL) {
          return objCall[CALL];
        }
      }
      return null
    };
    console.log(c, response);
    let contact = searchCall(c.callId, response.CALLS);
    if (contact == null) {
      chrome.runtime.sendMessage({messageType: 'CREATING_CONTACT', contact: c, contactId: c.Id, removeCall: true})
    }
    chrome.runtime.sendMessage({messageType: 'CREATING_CONTACT', contact: c, contactId: c.Id, removeCall: false});
  }
};
/**
 * Sending request to ready for work
 */
chrome.runtime.sendMessage({messageType: 'REGISTER'}, response => {
  if ($('#sign-out').length > 0 || $('#loginForm').length > 0 || response === undefined) {
    return;
  }
  if (response.messageType === 'REGISTER' && response.messageText === 'OK') {
    $(document).ready(() => {
      if (location.href.indexOf('search') !== -1 || location.href.indexOf('Contact') !== -1 || location.href.indexOf('manageOpportunity') !== -1) {
        $(document).on('click', '.w-call', async function () {
          let phoneNumber = null;
          let appIdContact = null;
          let idContact, contactData, strNeighbourEl, indexContactPhone;
          const findIDContact = (target, callBtnClass) => {
            if (callBtnClass === 'search') {
              if (location.href.indexOf('searchResults') !== -1) {
                const parent = target.parents('.chunk-container')[0];
                return parent.id.replace('chunk-container-', '');
              } else if (location.href.indexOf('searchTemplate') !== -1) {
                return target.closest('tr')[0].id.replace('chunk-', '');
              }
            } else if (callBtnClass === 'summary') {
              const tdContactLink = $(target.parents('tbody')[0]).find('#contactLink_data');
              const href = $($(tdContactLink).find('a')[0]).attr('href');
              return href.substring(href.indexOf('ID='), href.length).replace('ID=', '');
            } else if (callBtnClass === 'contact') {
              const url = new URL(window.location.href);
              return url.searchParams.get('ID');
            }
          };
          if ($(this).is('.call-contact')) {
            try {
              const idContact = findIDContact($(this), 'contact');
              console.log(idContact);
              let phoneInputs = $(this).closest('tr').find('input[type="text"]')[0];
              appIdContact = idContact;
              contactData = await getContact(idContact);
              if (typeof contactData !== 'undefined') {
                indexContactPhone = phoneInputs.id.replace('Contact0Phone', '');
                selectPhoneContact = 'Phone' + indexContactPhone;
                phoneNumber = contactData[selectPhoneContact];
              } else {
                let phones = [];
                phoneInputs.each(function (n, phoneInput) {
                  if ($(phoneInput).val().trim() !== '') {
                    phones.push($(phoneInput).val().trim());
                  }
                });
                if (phones.length !== 0) {
                  phoneNumber = phones[0];
                }
              }
            } catch (e) {
              console.error(e);
            }
          } else if ($(this).is('.call-search')) {
            try {
              idContact = findIDContact($(this), 'search');
              contactData = await getContact(idContact);
              appIdContact = idContact;
              let numberPhoneForSearch = $($(this).parents('.line')).find('strong')[0].innerText;
              numberPhoneForSearch = numberPhoneForSearch.trim().replace(' ', '').replace(':', '');
              if (typeof contactData !== 'undefined' || typeof contactData[numberPhoneForSearch] !== 'undefined') {
                phoneNumber = contactData[numberPhoneForSearch];
                selectPhoneContact = numberPhoneForSearch;
                if (!contactData[numberPhoneForSearch]) {
                  alert('Unable to dial the number, because. it is listed as optional');
                }
              } else {
                let strNeighbourEl = $(this).prev()[0].innerText;
                let arrData = strNeighbourEl.split(' ');
                phoneNumber = arrData[0];
              }
            } catch (e) {
              console.error(e);
            }
          } else if ($(this).is('.call-summary')) {
            try {
              idContact = findIDContact($(this), 'summary');
              contactData = await getContact(idContact);
              appIdContact = idContact;
              strNeighbourEl = $(this).prev()[0].innerText;
              const strNumberPhone = $(this).parent()[0].id;
              const replaceStr = 'contactPhone';
              indexContactPhone = strNumberPhone.substring(replaceStr.length, strNumberPhone.indexOf('_data'));
              if (typeof contactData !== 'undefined') {
                selectPhoneContact = 'Phone' + indexContactPhone;
                phoneNumber = contactData[selectPhoneContact];
              } else {
                let arrData = strNeighbourEl.split(' ');
                if (arrData.length > 2) {
                  phoneNumber = arrData[2];
                } else {
                  phoneNumber = arrData[0];
                }
              }
            } catch (e) {
              console.error(e);
            }
          }
          if (phoneNumber !== null && typeof phoneNumber !== 'undefined') {
            phoneNumber = removeSpecialCharacters(phoneNumber);
            chrome.runtime.sendMessage({
              messageType: 'MAKE_CALL',
              number: phoneNumber,
              idContact: appIdContact
            });
          }
          return false;
        });
      }
      if (location.href.indexOf('manageContact') !== -1 || location.href.indexOf('oldManageContact') !== -1) {
        parsePhones('CONTACT_DETAILS');
      } else if (location.href.indexOf('searchTemplate') !== -1 || location.href.indexOf('searchResult') !== -1) {
        parsePhones('SEARCH');
      } else if (location.href.indexOf('manageOpportunity') !== -1 || location.href.indexOf('opportunity') !== -1) {
        parsePhones('OPPORTUNITY_SUMMARY');
      } else {
        $(document).off('click', '.w-call');
      }
    });
    chrome.runtime.sendMessage({
      messageType: 'GET_CALLS'
    }, response => {
      notes = response.notes;
      for (let CALL in response.CALLS) {
        if (response.CALLS.hasOwnProperty(CALL)) {
          const contact = response.CALLS[CALL];
          const contactExisting = contact.Id.toString().indexOf('new') === -1;
          console.log(contact, contactExisting);
          drawCall(contact, contactExisting, contact['Phone' + contact.indexPhone] || contact.wmsPhone);
        }
      }
    });
  }
});
/**
 * Controller
 */
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
  if ($('#sign-out').length > 0 || $('#loginForm').length > 0) {
    return;
  }
  console.log('chrome.runtime.onMessage', request.messageType, request);
  const integrationClass = '.wildix-integration-invitation-popup';
  const collabarationErrorClass = '.wildix-collaboration-error-popup';
  const wiserviceErrorClass = '.wildix-wiservice-error-popup';
  switch (request.messageType) {
    case 'SHOW_SMALL_POPUP_EXISTING':
    case 'SHOW_SMALL_POPUP_NEW':
      if (callsEnded[request.contact.callId] !== undefined) {
        sendResponse({farewell: 'the call was ended'});
        return;
      }
      console.log(request.contact, request.phone);
      drawCall(request.contact, request.messageType === 'SHOW_SMALL_POPUP_EXISTING', request.phone);
      $(integrationClass).remove();
      sendResponse({farewell: 'tab received a call and showed small popup'});
      break;
    case 'HIDE_SMALL_POPUP':
      const popup = $('.wildix-small-call-popup[data-call-id="' + request.callId + '"]');
      const closeButton = popup.find('.avatar');
      selectPhoneContact = null;
      callsEnded[request.callId] = 'ended';
      popup.addClass('end-call-dialog');
      callControllers = callControllers.filter(controller => {
        if (controller.channel !== request.callId) {
          return true;
        }
        controller.state = 'remove';
      });
      closePopup = (smallPopup) => {
        smallPopup.remove();
        if ($('.wildix-small-call-popup').length === 0) {
          $(document).off('click', '.wildix-call-popups-container .wildix-call-popups-hide-button');
          removePopapContainer();
        }
        sendResponse({farewell: 'tab hid a popup'});
      };
      closeButton.removeAttr('style');
      closeButton.html(
        '<div class="wildix-close-button">' +
        '<img src="' + chrome.extension.getURL('images/icon_close.png') + '"/>' +
        '</div>'
      );
      closeButton.on('click', () => closePopup(popup));
      setTimeout(() => closePopup(popup), removePopupTime);
      break;
    case 'RECEIVE_NEW_NOTE':
      showNotes(request.contactId);
      break;
    case 'ADD_CONTACT_INFO':
      let contact = request.contact;
      contacts[request.contactId] = contact;
      console.log('ADD_CONTACT_INFO', request);
      let smallPopup = $('.wildix-small-call-popup[data-call-id="' + contact.callId + '"]');
      if (smallPopup.length !== 0) {
        smallPopup.find('.add-contact-button').replaceWith(
          '<div class="inf-button primary open-popup-button">' +
          '<div class="chunky-sprite note-icon" title="Notes"></div></div>'
        );
        smallPopup.find('.wildix-contact-title').replaceWith(
          '<div class="wildix-contact-title"><a href="' + contact.link + '">' +
          contact.FirstName + ' ' + contact.LastName + '</a></div>'
        );
      }
      break;
    case 'CLOSE_POPUP':
      $('#popup_' + request.contactId).remove();
      break;
    case 'PARSE_PHONE_NUMBERS_SEARCH_PAGE':
      parsePhones('SEARCH');
      break;
    case 'PARSE_PHONE_NUMBERS_CONTACT_PAGE':
      parsePhones('CONTACT_DETAILS');
      break;
    case 'SHOW_INTEGRATION_INVITE':
      console.log('SHOW_INTEGRATION_INVITE');
      if ($(integrationClass).length === 0) {
        let integrationInvitationPopup = $(
          '<div class="wildix-integration-invitation-popup">Wildix integration is not set. ' +
          '<span class="red">Cilck here to activate it.</span></div>'
        );
        $(document).on('click', integrationClass, onWildixIntegrationInvitationPopupClick);
        $('body').append(integrationInvitationPopup);
        removePopapContainer();
      }
      break;
    case 'SHOW_INTEGRATION_INVITE_AUTH_FAILED':
      console.log('SHOW_INTEGRATION_INVITE_AUTH_FAILED');
      if ($(integrationClass).length === 0) {
        let integrationInvitationAuthFailedPopup = $(
          '<div class="wildix-integration-invitation-popup height-60">Wildix integration is not set.<br/>' +
          'Authorization failed.<br/><span class="red">Click here to retry.</span></div>'
        );
        $(document).on('click', integrationClass, onWildixIntegrationInvitationPopupClick);
        $('body').append(integrationInvitationAuthFailedPopup);
      }
      break;
    case 'SHOW_COLLABORATION_NOT_OPENED_MESSAGE':
      console.log('SHOW_COLLABORATION_NOT_OPENED_MESSAGE');
      if ($(collabarationErrorClass).length === 0) {
        let collaborationNotOpenedPopup = $(
          '<div class="wildix-collaboration-error-popup">Collaboration is not opened</div>'
        );
        $('body').append(collaborationNotOpenedPopup);
      }
      break;
    case 'SHOW_WISERVICE_CONNECTION_ERROR_MESSAGE':
      console.log('SHOW_WISERVICE_CONNECTION_ERROR_MESSAGE');
      if ($(wiserviceErrorClass).length === 0) {
        let wiserviceErrorPopup = $(
          '<div class="wildix-wiservice-error-popup">Connection to WIService<br/>is lost</div>'
        );
        $('body').append(wiserviceErrorPopup);
      }
      break;
    case 'CLOSE_INTEGRATION_INVITATION_POPUP':
      console.log('CLOSE_INTEGRATION_INVITATION_POPUP');
      $(document).off('click', integrationClass);
      $(integrationClass).remove();
      break;
    case 'CLOSE_COLLABORATION_NOT_OPENED_MESSAGE':
      $(collabarationErrorClass).remove();
      break;
    case 'CLOSE_WISERVICE_CONNECTION_ERROR_MESSAGE':
      $(wiserviceErrorClass).remove();
      break;
    case 'GET_NOTES_BY_CONTACT':
      const dialog = $('.wildix-call-popup[data-id="' + request.contactId + '"]');
      let listNotes = request.listNotes;
      if (dialog.length !== 0) {
        const len = listNotes.length;
        if (len) {
          let notesDiv = $('<div class="wildix-popup-notes"></div>');
          for (let i = 0; i < len; i++) {
            if (listNotes[i].CreationNotes === undefined) {
              listNotes[i].CreationNotes = '';
            }
            notesDiv.append(
              '<div class="wildix-popup-note"><p class="noteSubjectText">' +
              listNotes[i].ActionDescription + '</p><p class="noteContentText">' +
              listNotes[i].CreationNotes + '</p></div>'
            );
          }
          dialog.find('.wildix-popup-notes').replaceWith(notesDiv);
          // TODO: add scroll to bottom
          dialog.find('.wildix-popup-notes').scrollTop(dialog.find('.wildix-popup-notes')[0].scrollHeight);
        }
      }
      break;
    case 'UPDATE_CALL':
      const updateCall = request.call;
      const controller = callControllers.find(item => item.channel === updateCall.channel);
      if (typeof controller !== 'undefined') {
        controller.state = updateCall.state;
      }
      break;
    case 'OPEN_CONTACT_WINDOW':
      if (request.data.link !== null) {
        window.open(request.data.link)
      }
      break;
  }
});

