window.isw = function () {
  return new Promise((resolve, reject) => {
    if ('serviceWorker' in navigator) {
      const swUrl = chrome.runtime.getURL('sw.js');
      navigator.serviceWorker.register(swUrl).then(function() {
        navigator.serviceWorker.ready.then(function(registration) {
          console.log('ServiceWorker registration successful and ready for using');
          resolve(registration)
        });
      }).catch((e) => {
        reject(new Error(e))
      })
    } else {
      reject(new Error('Your browser does not support the Service-Worker!'))
    }
  }).then(v => v)
};