/**
 * build num pad layout and register controller for this
 *
 */
const renderNumPad = () => {
  $('body').append('<div class="mainNumPad">' +
    '  <div class="buttonNumPad circleNumPad"><i class="fa fa-phone" aria-hidden="true"></i></div>' +
    '    <div class="containerNumPad">' +
    '    <div class="hideContainerNumPad"></div>' +
    '      <input type="text" id="outputNumPad" readonly>' +
    '      <div class="rowNumPad">' +
    '        <div class="digit">1</div>' +
    '        <div class="digit">2</div>' +
    '        <div class="digit">3</div>' +
    '      </div>' +
    '      <div class="rowNumPad">' +
    '        <div class="digit">4</div>' +
    '        <div class="digit">5</div>' +
    '        <div class="digit">6</div>' +
    '      </div>' +
    '      <div class="rowNumPad">' +
    '        <div class="digit">7</div>' +
    '        <div class="digit">8</div>' +
    '        <div class="digit">9</div>' +
    '      </div>' +
    '      <div class="rowNumPad">' +
    '        <div class="digit">*</div>' +
    '        <div class="digit">0</div>' +
    '        <div class="digit">#</div>' +
    '      </div>' +
    '      <div>' +
    '        <i class="fa fa-long-arrow-left dig" aria-hidden="true"></i>' +
    '        <div class="digit plusNumPad">+</div>' +
    '        <div id="callNumPad"><i class="fa fa-phone" aria-hidden="true"></i></div>' +
    '      </div>' +
    '    </div>' +
    '  </div>' +
    '</div>');
};
class ControllerNumPad {
  constructor(countNumPad, container, hideContainerNumPad, outputNumPad, mainNumPud) {
    this.countNumPad = countNumPad;
    this.container = container;
    this.hideContainerNumPad = hideContainerNumPad;
    this.outputNumPad = outputNumPad;
    this.mainNumPud = mainNumPud;
    this.keyUpMainNumPudHide = false
  }
  toggleVisibility() {
    if (this.container) {
      if (this.container.hasClass('hideNumPad')) {
        this.container.css({opacity: 0}).removeClass('hideNumPad').hide();
        this.hideContainerNumPad.addClass('hideContainerNumPad');
      } else {
        this.container.css({opacity: 1}).addClass('hideNumPad').show();
        this.hideContainerNumPad.removeClass('hideContainerNumPad');
      }
    }
  }
  toggleVisibilityMainNumPud(event) {
    if (event.clientX === 0) {
      this.mainNumPud.css({left: '15px'});
      this.keyUpMainNumPudHide = true;
    } else if (event.clientX > 330 && !this.container.hasClass('hideNumPad')) {
      this.mainNumPud.css({left: '-315px'});
      this.keyUpMainNumPudHide = false;
    }

  }
  removeNumPadSymbol() {
    let strData = this.outputNumPad.val();
    strData = strData.slice(0, -1);
    this.outputNumPad.val(strData);
    this.countNumPad--;
  }
  addNumPadSymbol(data) {
    this.outputNumPad.val(this.outputNumPad.val() + data);
    this.countNumPad++;
  }
  keyUp(event) {
    if (!this.container.hasClass('hideNumPad') || (document.activeElement.tagName === 'INPUT' && document.activeElement.id !== 'outputNumPad') || document.activeElement.tagName === 'TEXTAREA' || !this.keyUpMainNumPudHide) {
      return false;
    }
    if (event.key === 'Backspace') {
      this.removeNumPadSymbol();
    } else if (event.key === 'Enter') {
      this.call();
    } else if (this.countNumPad < 30) {
      if (this.checkSymbol(event.keyCode, {
          1: "",
          2: "ABC",
          3: "DEF",
          4: "GHI",
          5: "JKL",
          6: "MNO",
          7: "PQRS",
          8: "TUV",
          9: "WXYZ",
          10: "+#*",
          12: "123",
          13: "456",
          14: "789",
          15: "0"
        }, event.key)) {
        this.addNumPadSymbol(event.key);
      }
    }
    return false;
  }
  digitClick(number) {
    if (this.countNumPad < 30) {
      this.addNumPadSymbol(number);
    }
  }
  checkSymbol(keyCode, keyMap, keys) {
    if (keyCode === 106) return '*';
    for (let key in keyMap) if (keyMap[key].toLowerCase().indexOf(keys) >= 0 || keyMap[key].toUpperCase().indexOf(keys) >= 0) return key;
    return false;
  }
  call() {
    const strDataNumber = this.outputNumPad.val();
    if (strDataNumber.length !== 0) {
      try {
        chrome.runtime.sendMessage({
          messageType: 'MAKE_CALL',
          number: strDataNumber
        });
        this.outputNumPad.val('');
      } catch (err) {
        console.error(err);
      }
    }
  }
}