const removeSpecialCharacters = num => {
  if (typeof num !== 'undefined') {
    return num.trim().replace(/[.,!?^${}()|\-/ig[\]\\]/g, '').replace(/\s+/g, '');
  }
  return null
};
// Remove popup container
const removePopapContainer = () => {
  $('.wildix-call-popups-container').remove();
};
//SEND MESSAGE TO BACKGROUND FOR START INTEGRATION (BECAUSE FROM CONTENT WE CAN'T OPEN CHROME.TABS)
const onWildixIntegrationInvitationPopupClick = () => chrome.runtime.sendMessage({messageType: 'START_INTEGRATION'});
/**
 * Function of generating an avatar from the name in 2 letters and a colored circle
 *
 * @param user
 * @returns {string}
 */
const searchLetterInUser = user => {
  try{
    if (user.FirstName.length === 0 && user.LastName.length === 0) {
      return user.indexPhone ? user['Phone' + user.indexPhone][0] + user['Phone' + user.indexPhone][1] : user.wmsPhone[0] + user.wmsPhone[1]
    } else if (user.FirstName.length !== 0 && user.LastName.length !== 0) {
      return user.FirstName[0] + user.LastName[0]
    } else if (user.FirstName.length >= 2) {
      return user.FirstName[0] + user.FirstName[1]
    } else if (user.LastName.length >= 2) {
      return user.LastName[0] + user.LastName[1]
    }
    return user.wmsPhone[0] + user.wmsPhone[1]
  } catch (e) {
    console.error(e);
    return 'AB'
  }
};
const generateAvatar = user => {
  let letter = searchLetterInUser(user);
  let hash = 0;
  let color = '#';
  const str = user.FirstName + user.LastName + user['Phone' + user.indexPhone];
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  for (let i = 0; i < 3; i++) {
    let value = (hash >> (i * 8)) & 0xFF;
    color += ('00' + value.toString(16)).substr(-2);
  }
  return '<div class="avatar" style="background: ' + color + '">' + letter.toUpperCase() + '</div>';
};
const getContact = (idContact) => {
  return new Promise((resolve, reject) => {
    chrome.runtime.sendMessage({
      messageType: 'GET_CONTACT_BY_ID',
      id: idContact
    }, response => {
      if (!response) {
        reject(new Error('failed contact by id'));
      }
      resolve(response);
    });
  }).then(v => v);
};
let parsePhones = pageType => {
  console.log('parse DOM for phone numbers', pageType);
  switch (pageType) {
    case'SEARCH':
      let phoneDivs = $('#pagecontent').find('[name*="phoneWithExtension"]').find('.line').find('.chunk-data');
      phoneDivs.each(function (number, phoneDiv) {
        if ($(phoneDiv).siblings('.w-call').length === 0) {
          let phoneText = $(phoneDiv).html().trim();
          if (phoneText !== '') {
            $(phoneDiv).after(
              '<span class="w-call call-search"><img src="' +
              chrome.extension.getURL('images/w-call-17.png') + '"/></span>'
            );
          }
        }
      });
      break;
    case'CONTACT_DETAILS':
      let phoneTables = $('#ContactForm').find('[id^="Contact0Phone"]').children('table').children('tbody').children('tr:first-of-type');
      phoneTables.each((number, phoneRow) => {
        if ($(phoneRow).find('.w-call').length === 0) {
          let phoneInputs = $(phoneRow).find('input[type="text"]');
          let phones = [];
          phoneInputs.each((n, phoneInput) => {
            if ($(phoneInput).val().trim() !== '') {
              phones.push($(phoneInput).val().trim());
            }
          });
          let phoneJoined = phones.join('').trim();
          if (phoneJoined !== '') {
            $('<td><span class="w-call call-contact"><img src="' + chrome.extension.getURL('images/w-call-18.png') + '"/></span></td>').insertAfter(phoneInputs[0].closest("td"));
          }
        }
      });
      break;
    case'OPPORTUNITY_SUMMARY':
      $(window).on('load', () => {
        let phoneRow = $('#_summaryView td').filter(function (index, item) {
          return item.id.indexOf('contactPhone') !== -1;
        });
        if (phoneRow.length !== 0) {
          phoneRow.each((index, item) => {
            $('#' + item.id).css({display: 'flex'}).append('<span class="w-call call-summary">' +
              '<img src="' + chrome.extension.getURL('images/w-call-18.png') + '"/></span>');
          })
        }
      });
      break;
    default:
      break;
  }
};