(function () {
    window.oauth2 = {

        access_token_url: "https://api.infusionsoft.com/token",
        api_url: "https://api.infusionsoft.com/crm/rest/v1",
        authorization_url: "https://signin.infusionsoft.com/app/oauth/authorize",
        client_id: "nmvkhr8mqvkchra3rnhtbwvv",
        client_secret: "EvQK79a64k",
        scope: 'full',
        response_type: 'code',
        requestPermission: (redirect_uri) => {
            const _this = window.oauth2;
            let url = _this.authorization_url + "?client_id=" + _this.client_id + "&redirect_uri=" + redirect_uri + "&response_type=" + _this.response_type + "&scope=" + _this.scope;
            chrome.windows.create({url: url, focused: true, width: 650, height: 550});
        },

        /**
         * Finishes the oauth2 process by exchanging the given authorization code for an
         * authorization token. The authorization token is saved to the browsers local storage.
         * If the redirect page does not return an authorization code or an error occurs when
         * exchanging the authorization code for an authorization token then the oauth2 process dies
         * and the authorization tab is closed.
         *
         * @param url The url of the redirect page specified in the authorization request.
         */
        requestAccessToken: function (url) {
            return new Promise((resolve, reject) => {
                const code = url.match(/code=([\w\/\-]+)/)[1];
                this.getRedirectUrl(function (redirect_uri) {
                    const data = {
                        client_id: this.client_id,
                        client_secret: this.client_secret,
                        code: code,
                        grant_type: 'authorization_code',
                        redirect_uri: redirect_uri || window.oauth2.redirect_uri
                    };
                    $.ajax({
                        url: this.access_token_url,
                        type: 'POST',
                        dataType: 'json',
                        data: data,
                        success: function (tokenResponse) {
                            resolve(tokenResponse);
                        },
                        error: function (jqXHR) {
                            console.log('some error during requesting an access token', jqXHR);
                            reject(jqXHR);
                        }
                    });
                });
            });
        },

        refreshAccessToken: function (refreshToken) {
            return new Promise((resolve, reject) => {
                const data = {
                    refresh_token: refreshToken,
                    grant_type: 'refresh_token'
                };

                $.ajax({
                    url: this.access_token_url,
                    type: 'POST',
                    dataType: 'json',
                    headers: {
                        'Authorization': 'Basic ' + btoa(this.client_id + ':' + this.client_secret),
                    },
                    data: data,
                    success: function (tokenResponse) {
                        resolve(tokenResponse);
                    },
                    error: function (jqXHR) {
                        console.log('some error during refreshing an access token', jqXHR);
                        reject(jqXHR);
                    }
                });
            });
        },

        getRedirectUrl: function(callback) {
          chrome.runtime.sendMessage({ messageType: "GET_REDIRECT_URI"}, callback.bind(this));
        }
    }
})();
