function removeTab() {
    chrome.tabs.getCurrent(function (tab) {
        chrome.tabs.remove(tab.id);
    });
}

if (window.location.href.match(/error=(.+)/)) {
    console.log('some error');

    $('body').css('background', 'none');
    $(document).on('click', '.auth-error .start-auth', function () {
        removeTab();
        window.oauth2.getRedirectUrl(function (redirect_uri) {
            window.oauth2.requestPermission(redirect_uri);
        });
    });
    $('.auth-error').show();
} else {
    window.oauth2.requestAccessToken(window.location.href).then(tokenResponse => {
        infusionsoftAPI.processAccessToken(tokenResponse).then(accessToken => {
            infusionsoftAPI.storeAccessTokenInStorage(accessToken);
            chrome.runtime.sendMessage({
                messageType: "CLOSE_INTEGRATION_INVITATION_POPUP",
                token: accessToken
            });

            removeTab();
        }).catch(message => {
            console.log(message);
        });
    });
}
