const createNotification  = function (icon, title, callType, channelCall, link) {
  const interaction = navigator.platform.indexOf('Win') !== -1 ? false : true;
  const options = {
    body: callType.replace(callType[0], callType[0].toUpperCase()) + ' call',
    icon: icon,
    requireInteraction: interaction,
    data: {
      channelCall,
      callType,
      link: link
    },
    actions: [
      {
        action: 'answerCall',
        title: 'Answer',
      },
      {
        action: 'rejectCall',
        title: 'Reject',
      }
    ]
  };
  if (callType === 'outgoing') {
    options.actions.shift()
  }
  console.log('showNotification', title, options);
  self.registration.showNotification(title, options);
};
const onMessage = function (e) {
  const data = e.data;
  createNotification(data.icon, data.title, data.callType, data.channel, data.link);
};
const getClient = () => {
  return new Promise((resolve, reject) => {
    self.clients.matchAll({type: 'window'}).then(cl => {
      const client = cl.find(c => c.url.indexOf('background.html') !== -1);
      if (typeof client !== 'undefined') {
        resolve(client);
      }
    }).catch((e) => {
      reject(new Error(e));
    });
  }).then(v => v);
};
const notificationClick = function(e) {
  const dataToBg = e.notification.data;
  getClient().then(client => {
    if (!e.action) {
      client.postMessage({action: 'click', data: dataToBg});
      return null;
    }
    return client;
  }).then(client => {
    if (client !== null) {
      switch (e.action) {
        case 'answerCall':
          client.postMessage({action: 'answer-call', data: dataToBg});
          break;
        case 'rejectCall':
          client.postMessage({action: 'reject-call', data: dataToBg});
          break;
      }
    }
  }).catch(e => {
    console.error(e);
  });
};
self.addEventListener('install', function(e) {
  e.waitUntil(self.skipWaiting());
  console.log('SW install');
});
self.addEventListener('activate', function(e) {
  e.waitUntil(self.clients.claim());
});
self.addEventListener('notificationclick', notificationClick);
self.addEventListener('message', onMessage);
